// Code generated by go-swagger; DO NOT EDIT.

package alliance

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"net/http"
	"time"

	"golang.org/x/net/context"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/swag"

	strfmt "github.com/go-openapi/strfmt"
)

// NewGetAlliancesNamesParams creates a new GetAlliancesNamesParams object
// with the default values initialized.
func NewGetAlliancesNamesParams() *GetAlliancesNamesParams {
	var (
		datasourceDefault = string("tranquility")
	)
	return &GetAlliancesNamesParams{
		Datasource: &datasourceDefault,

		timeout: cr.DefaultTimeout,
	}
}

// NewGetAlliancesNamesParamsWithTimeout creates a new GetAlliancesNamesParams object
// with the default values initialized, and the ability to set a timeout on a request
func NewGetAlliancesNamesParamsWithTimeout(timeout time.Duration) *GetAlliancesNamesParams {
	var (
		datasourceDefault = string("tranquility")
	)
	return &GetAlliancesNamesParams{
		Datasource: &datasourceDefault,

		timeout: timeout,
	}
}

// NewGetAlliancesNamesParamsWithContext creates a new GetAlliancesNamesParams object
// with the default values initialized, and the ability to set a context for a request
func NewGetAlliancesNamesParamsWithContext(ctx context.Context) *GetAlliancesNamesParams {
	var (
		datasourceDefault = string("tranquility")
	)
	return &GetAlliancesNamesParams{
		Datasource: &datasourceDefault,

		Context: ctx,
	}
}

// NewGetAlliancesNamesParamsWithHTTPClient creates a new GetAlliancesNamesParams object
// with the default values initialized, and the ability to set a custom HTTPClient for a request
func NewGetAlliancesNamesParamsWithHTTPClient(client *http.Client) *GetAlliancesNamesParams {
	var (
		datasourceDefault = string("tranquility")
	)
	return &GetAlliancesNamesParams{
		Datasource: &datasourceDefault,
		HTTPClient: client,
	}
}

/*GetAlliancesNamesParams contains all the parameters to send to the API endpoint
for the get alliances names operation typically these are written to a http.Request
*/
type GetAlliancesNamesParams struct {

	/*XUserAgent
	  Client identifier, takes precedence over User-Agent

	*/
	XUserAgent *string
	/*AllianceIds
	  A comma separated list of alliance IDs

	*/
	AllianceIds []int64
	/*Datasource
	  The server name you would like data from

	*/
	Datasource *string
	/*UserAgent
	  Client identifier, takes precedence over headers

	*/
	UserAgent *string

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithTimeout adds the timeout to the get alliances names params
func (o *GetAlliancesNamesParams) WithTimeout(timeout time.Duration) *GetAlliancesNamesParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the get alliances names params
func (o *GetAlliancesNamesParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the get alliances names params
func (o *GetAlliancesNamesParams) WithContext(ctx context.Context) *GetAlliancesNamesParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the get alliances names params
func (o *GetAlliancesNamesParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the get alliances names params
func (o *GetAlliancesNamesParams) WithHTTPClient(client *http.Client) *GetAlliancesNamesParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the get alliances names params
func (o *GetAlliancesNamesParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithXUserAgent adds the xUserAgent to the get alliances names params
func (o *GetAlliancesNamesParams) WithXUserAgent(xUserAgent *string) *GetAlliancesNamesParams {
	o.SetXUserAgent(xUserAgent)
	return o
}

// SetXUserAgent adds the xUserAgent to the get alliances names params
func (o *GetAlliancesNamesParams) SetXUserAgent(xUserAgent *string) {
	o.XUserAgent = xUserAgent
}

// WithAllianceIds adds the allianceIds to the get alliances names params
func (o *GetAlliancesNamesParams) WithAllianceIds(allianceIds []int64) *GetAlliancesNamesParams {
	o.SetAllianceIds(allianceIds)
	return o
}

// SetAllianceIds adds the allianceIds to the get alliances names params
func (o *GetAlliancesNamesParams) SetAllianceIds(allianceIds []int64) {
	o.AllianceIds = allianceIds
}

// WithDatasource adds the datasource to the get alliances names params
func (o *GetAlliancesNamesParams) WithDatasource(datasource *string) *GetAlliancesNamesParams {
	o.SetDatasource(datasource)
	return o
}

// SetDatasource adds the datasource to the get alliances names params
func (o *GetAlliancesNamesParams) SetDatasource(datasource *string) {
	o.Datasource = datasource
}

// WithUserAgent adds the userAgent to the get alliances names params
func (o *GetAlliancesNamesParams) WithUserAgent(userAgent *string) *GetAlliancesNamesParams {
	o.SetUserAgent(userAgent)
	return o
}

// SetUserAgent adds the userAgent to the get alliances names params
func (o *GetAlliancesNamesParams) SetUserAgent(userAgent *string) {
	o.UserAgent = userAgent
}

// WriteToRequest writes these params to a swagger request
func (o *GetAlliancesNamesParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error

	if o.XUserAgent != nil {

		// header param X-User-Agent
		if err := r.SetHeaderParam("X-User-Agent", *o.XUserAgent); err != nil {
			return err
		}

	}

	var valuesAllianceIds []string
	for _, v := range o.AllianceIds {
		valuesAllianceIds = append(valuesAllianceIds, swag.FormatInt64(v))
	}

	joinedAllianceIds := swag.JoinByFormat(valuesAllianceIds, "")
	// query array param alliance_ids
	if err := r.SetQueryParam("alliance_ids", joinedAllianceIds...); err != nil {
		return err
	}

	if o.Datasource != nil {

		// query param datasource
		var qrDatasource string
		if o.Datasource != nil {
			qrDatasource = *o.Datasource
		}
		qDatasource := qrDatasource
		if qDatasource != "" {
			if err := r.SetQueryParam("datasource", qDatasource); err != nil {
				return err
			}
		}

	}

	if o.UserAgent != nil {

		// query param user_agent
		var qrUserAgent string
		if o.UserAgent != nil {
			qrUserAgent = *o.UserAgent
		}
		qUserAgent := qrUserAgent
		if qUserAgent != "" {
			if err := r.SetQueryParam("user_agent", qUserAgent); err != nil {
				return err
			}
		}

	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
