// Code generated by go-swagger; DO NOT EDIT.

package character

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"net/http"
	"time"

	"golang.org/x/net/context"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/swag"

	strfmt "github.com/go-openapi/strfmt"
)

// NewGetCharactersCharacterIDPortraitParams creates a new GetCharactersCharacterIDPortraitParams object
// with the default values initialized.
func NewGetCharactersCharacterIDPortraitParams() *GetCharactersCharacterIDPortraitParams {
	var (
		datasourceDefault = string("tranquility")
	)
	return &GetCharactersCharacterIDPortraitParams{
		Datasource: &datasourceDefault,

		timeout: cr.DefaultTimeout,
	}
}

// NewGetCharactersCharacterIDPortraitParamsWithTimeout creates a new GetCharactersCharacterIDPortraitParams object
// with the default values initialized, and the ability to set a timeout on a request
func NewGetCharactersCharacterIDPortraitParamsWithTimeout(timeout time.Duration) *GetCharactersCharacterIDPortraitParams {
	var (
		datasourceDefault = string("tranquility")
	)
	return &GetCharactersCharacterIDPortraitParams{
		Datasource: &datasourceDefault,

		timeout: timeout,
	}
}

// NewGetCharactersCharacterIDPortraitParamsWithContext creates a new GetCharactersCharacterIDPortraitParams object
// with the default values initialized, and the ability to set a context for a request
func NewGetCharactersCharacterIDPortraitParamsWithContext(ctx context.Context) *GetCharactersCharacterIDPortraitParams {
	var (
		datasourceDefault = string("tranquility")
	)
	return &GetCharactersCharacterIDPortraitParams{
		Datasource: &datasourceDefault,

		Context: ctx,
	}
}

// NewGetCharactersCharacterIDPortraitParamsWithHTTPClient creates a new GetCharactersCharacterIDPortraitParams object
// with the default values initialized, and the ability to set a custom HTTPClient for a request
func NewGetCharactersCharacterIDPortraitParamsWithHTTPClient(client *http.Client) *GetCharactersCharacterIDPortraitParams {
	var (
		datasourceDefault = string("tranquility")
	)
	return &GetCharactersCharacterIDPortraitParams{
		Datasource: &datasourceDefault,
		HTTPClient: client,
	}
}

/*GetCharactersCharacterIDPortraitParams contains all the parameters to send to the API endpoint
for the get characters character id portrait operation typically these are written to a http.Request
*/
type GetCharactersCharacterIDPortraitParams struct {

	/*XUserAgent
	  Client identifier, takes precedence over User-Agent

	*/
	XUserAgent *string
	/*CharacterID
	  An EVE character ID

	*/
	CharacterID int32
	/*Datasource
	  The server name you would like data from

	*/
	Datasource *string
	/*UserAgent
	  Client identifier, takes precedence over headers

	*/
	UserAgent *string

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithTimeout adds the timeout to the get characters character id portrait params
func (o *GetCharactersCharacterIDPortraitParams) WithTimeout(timeout time.Duration) *GetCharactersCharacterIDPortraitParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the get characters character id portrait params
func (o *GetCharactersCharacterIDPortraitParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the get characters character id portrait params
func (o *GetCharactersCharacterIDPortraitParams) WithContext(ctx context.Context) *GetCharactersCharacterIDPortraitParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the get characters character id portrait params
func (o *GetCharactersCharacterIDPortraitParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the get characters character id portrait params
func (o *GetCharactersCharacterIDPortraitParams) WithHTTPClient(client *http.Client) *GetCharactersCharacterIDPortraitParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the get characters character id portrait params
func (o *GetCharactersCharacterIDPortraitParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithXUserAgent adds the xUserAgent to the get characters character id portrait params
func (o *GetCharactersCharacterIDPortraitParams) WithXUserAgent(xUserAgent *string) *GetCharactersCharacterIDPortraitParams {
	o.SetXUserAgent(xUserAgent)
	return o
}

// SetXUserAgent adds the xUserAgent to the get characters character id portrait params
func (o *GetCharactersCharacterIDPortraitParams) SetXUserAgent(xUserAgent *string) {
	o.XUserAgent = xUserAgent
}

// WithCharacterID adds the characterID to the get characters character id portrait params
func (o *GetCharactersCharacterIDPortraitParams) WithCharacterID(characterID int32) *GetCharactersCharacterIDPortraitParams {
	o.SetCharacterID(characterID)
	return o
}

// SetCharacterID adds the characterId to the get characters character id portrait params
func (o *GetCharactersCharacterIDPortraitParams) SetCharacterID(characterID int32) {
	o.CharacterID = characterID
}

// WithDatasource adds the datasource to the get characters character id portrait params
func (o *GetCharactersCharacterIDPortraitParams) WithDatasource(datasource *string) *GetCharactersCharacterIDPortraitParams {
	o.SetDatasource(datasource)
	return o
}

// SetDatasource adds the datasource to the get characters character id portrait params
func (o *GetCharactersCharacterIDPortraitParams) SetDatasource(datasource *string) {
	o.Datasource = datasource
}

// WithUserAgent adds the userAgent to the get characters character id portrait params
func (o *GetCharactersCharacterIDPortraitParams) WithUserAgent(userAgent *string) *GetCharactersCharacterIDPortraitParams {
	o.SetUserAgent(userAgent)
	return o
}

// SetUserAgent adds the userAgent to the get characters character id portrait params
func (o *GetCharactersCharacterIDPortraitParams) SetUserAgent(userAgent *string) {
	o.UserAgent = userAgent
}

// WriteToRequest writes these params to a swagger request
func (o *GetCharactersCharacterIDPortraitParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error

	if o.XUserAgent != nil {

		// header param X-User-Agent
		if err := r.SetHeaderParam("X-User-Agent", *o.XUserAgent); err != nil {
			return err
		}

	}

	// path param character_id
	if err := r.SetPathParam("character_id", swag.FormatInt32(o.CharacterID)); err != nil {
		return err
	}

	if o.Datasource != nil {

		// query param datasource
		var qrDatasource string
		if o.Datasource != nil {
			qrDatasource = *o.Datasource
		}
		qDatasource := qrDatasource
		if qDatasource != "" {
			if err := r.SetQueryParam("datasource", qDatasource); err != nil {
				return err
			}
		}

	}

	if o.UserAgent != nil {

		// query param user_agent
		var qrUserAgent string
		if o.UserAgent != nil {
			qrUserAgent = *o.UserAgent
		}
		qUserAgent := qrUserAgent
		if qUserAgent != "" {
			if err := r.SetQueryParam("user_agent", qUserAgent); err != nil {
				return err
			}
		}

	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
