// Code generated by go-swagger; DO NOT EDIT.

package character

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"net/http"
	"time"

	"golang.org/x/net/context"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/swag"

	strfmt "github.com/go-openapi/strfmt"

	"git.inf3.xyz/tschwery/eve-goclient.git/models"
)

// NewPostCharactersCharacterIDCspaParams creates a new PostCharactersCharacterIDCspaParams object
// with the default values initialized.
func NewPostCharactersCharacterIDCspaParams() *PostCharactersCharacterIDCspaParams {
	var (
		datasourceDefault = string("tranquility")
	)
	return &PostCharactersCharacterIDCspaParams{
		Datasource: &datasourceDefault,

		timeout: cr.DefaultTimeout,
	}
}

// NewPostCharactersCharacterIDCspaParamsWithTimeout creates a new PostCharactersCharacterIDCspaParams object
// with the default values initialized, and the ability to set a timeout on a request
func NewPostCharactersCharacterIDCspaParamsWithTimeout(timeout time.Duration) *PostCharactersCharacterIDCspaParams {
	var (
		datasourceDefault = string("tranquility")
	)
	return &PostCharactersCharacterIDCspaParams{
		Datasource: &datasourceDefault,

		timeout: timeout,
	}
}

// NewPostCharactersCharacterIDCspaParamsWithContext creates a new PostCharactersCharacterIDCspaParams object
// with the default values initialized, and the ability to set a context for a request
func NewPostCharactersCharacterIDCspaParamsWithContext(ctx context.Context) *PostCharactersCharacterIDCspaParams {
	var (
		datasourceDefault = string("tranquility")
	)
	return &PostCharactersCharacterIDCspaParams{
		Datasource: &datasourceDefault,

		Context: ctx,
	}
}

// NewPostCharactersCharacterIDCspaParamsWithHTTPClient creates a new PostCharactersCharacterIDCspaParams object
// with the default values initialized, and the ability to set a custom HTTPClient for a request
func NewPostCharactersCharacterIDCspaParamsWithHTTPClient(client *http.Client) *PostCharactersCharacterIDCspaParams {
	var (
		datasourceDefault = string("tranquility")
	)
	return &PostCharactersCharacterIDCspaParams{
		Datasource: &datasourceDefault,
		HTTPClient: client,
	}
}

/*PostCharactersCharacterIDCspaParams contains all the parameters to send to the API endpoint
for the post characters character id cspa operation typically these are written to a http.Request
*/
type PostCharactersCharacterIDCspaParams struct {

	/*XUserAgent
	  Client identifier, takes precedence over User-Agent

	*/
	XUserAgent *string
	/*CharacterID
	  An EVE character ID

	*/
	CharacterID int32
	/*Characters
	  The target characters to calculate the charge for

	*/
	Characters *models.PostCharactersCharacterIDCspaParamsBody
	/*Datasource
	  The server name you would like data from

	*/
	Datasource *string
	/*Token
	  Access token to use if unable to set a header

	*/
	Token *string
	/*UserAgent
	  Client identifier, takes precedence over headers

	*/
	UserAgent *string

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithTimeout adds the timeout to the post characters character id cspa params
func (o *PostCharactersCharacterIDCspaParams) WithTimeout(timeout time.Duration) *PostCharactersCharacterIDCspaParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the post characters character id cspa params
func (o *PostCharactersCharacterIDCspaParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the post characters character id cspa params
func (o *PostCharactersCharacterIDCspaParams) WithContext(ctx context.Context) *PostCharactersCharacterIDCspaParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the post characters character id cspa params
func (o *PostCharactersCharacterIDCspaParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the post characters character id cspa params
func (o *PostCharactersCharacterIDCspaParams) WithHTTPClient(client *http.Client) *PostCharactersCharacterIDCspaParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the post characters character id cspa params
func (o *PostCharactersCharacterIDCspaParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithXUserAgent adds the xUserAgent to the post characters character id cspa params
func (o *PostCharactersCharacterIDCspaParams) WithXUserAgent(xUserAgent *string) *PostCharactersCharacterIDCspaParams {
	o.SetXUserAgent(xUserAgent)
	return o
}

// SetXUserAgent adds the xUserAgent to the post characters character id cspa params
func (o *PostCharactersCharacterIDCspaParams) SetXUserAgent(xUserAgent *string) {
	o.XUserAgent = xUserAgent
}

// WithCharacterID adds the characterID to the post characters character id cspa params
func (o *PostCharactersCharacterIDCspaParams) WithCharacterID(characterID int32) *PostCharactersCharacterIDCspaParams {
	o.SetCharacterID(characterID)
	return o
}

// SetCharacterID adds the characterId to the post characters character id cspa params
func (o *PostCharactersCharacterIDCspaParams) SetCharacterID(characterID int32) {
	o.CharacterID = characterID
}

// WithCharacters adds the characters to the post characters character id cspa params
func (o *PostCharactersCharacterIDCspaParams) WithCharacters(characters *models.PostCharactersCharacterIDCspaParamsBody) *PostCharactersCharacterIDCspaParams {
	o.SetCharacters(characters)
	return o
}

// SetCharacters adds the characters to the post characters character id cspa params
func (o *PostCharactersCharacterIDCspaParams) SetCharacters(characters *models.PostCharactersCharacterIDCspaParamsBody) {
	o.Characters = characters
}

// WithDatasource adds the datasource to the post characters character id cspa params
func (o *PostCharactersCharacterIDCspaParams) WithDatasource(datasource *string) *PostCharactersCharacterIDCspaParams {
	o.SetDatasource(datasource)
	return o
}

// SetDatasource adds the datasource to the post characters character id cspa params
func (o *PostCharactersCharacterIDCspaParams) SetDatasource(datasource *string) {
	o.Datasource = datasource
}

// WithToken adds the token to the post characters character id cspa params
func (o *PostCharactersCharacterIDCspaParams) WithToken(token *string) *PostCharactersCharacterIDCspaParams {
	o.SetToken(token)
	return o
}

// SetToken adds the token to the post characters character id cspa params
func (o *PostCharactersCharacterIDCspaParams) SetToken(token *string) {
	o.Token = token
}

// WithUserAgent adds the userAgent to the post characters character id cspa params
func (o *PostCharactersCharacterIDCspaParams) WithUserAgent(userAgent *string) *PostCharactersCharacterIDCspaParams {
	o.SetUserAgent(userAgent)
	return o
}

// SetUserAgent adds the userAgent to the post characters character id cspa params
func (o *PostCharactersCharacterIDCspaParams) SetUserAgent(userAgent *string) {
	o.UserAgent = userAgent
}

// WriteToRequest writes these params to a swagger request
func (o *PostCharactersCharacterIDCspaParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error

	if o.XUserAgent != nil {

		// header param X-User-Agent
		if err := r.SetHeaderParam("X-User-Agent", *o.XUserAgent); err != nil {
			return err
		}

	}

	// path param character_id
	if err := r.SetPathParam("character_id", swag.FormatInt32(o.CharacterID)); err != nil {
		return err
	}

	if o.Characters == nil {
		o.Characters = new(models.PostCharactersCharacterIDCspaParamsBody)
	}

	if err := r.SetBodyParam(o.Characters); err != nil {
		return err
	}

	if o.Datasource != nil {

		// query param datasource
		var qrDatasource string
		if o.Datasource != nil {
			qrDatasource = *o.Datasource
		}
		qDatasource := qrDatasource
		if qDatasource != "" {
			if err := r.SetQueryParam("datasource", qDatasource); err != nil {
				return err
			}
		}

	}

	if o.Token != nil {

		// query param token
		var qrToken string
		if o.Token != nil {
			qrToken = *o.Token
		}
		qToken := qrToken
		if qToken != "" {
			if err := r.SetQueryParam("token", qToken); err != nil {
				return err
			}
		}

	}

	if o.UserAgent != nil {

		// query param user_agent
		var qrUserAgent string
		if o.UserAgent != nil {
			qrUserAgent = *o.UserAgent
		}
		qUserAgent := qrUserAgent
		if qUserAgent != "" {
			if err := r.SetQueryParam("user_agent", qUserAgent); err != nil {
				return err
			}
		}

	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
