// Code generated by go-swagger; DO NOT EDIT.

package contacts

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"net/http"
	"time"

	"golang.org/x/net/context"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/swag"

	strfmt "github.com/go-openapi/strfmt"
)

// NewPutCharactersCharacterIDContactsParams creates a new PutCharactersCharacterIDContactsParams object
// with the default values initialized.
func NewPutCharactersCharacterIDContactsParams() *PutCharactersCharacterIDContactsParams {
	var (
		datasourceDefault = string("tranquility")
		labelIDDefault    = int64(0)
		watchedDefault    = bool(false)
	)
	return &PutCharactersCharacterIDContactsParams{
		Datasource: &datasourceDefault,
		LabelID:    &labelIDDefault,
		Watched:    &watchedDefault,

		timeout: cr.DefaultTimeout,
	}
}

// NewPutCharactersCharacterIDContactsParamsWithTimeout creates a new PutCharactersCharacterIDContactsParams object
// with the default values initialized, and the ability to set a timeout on a request
func NewPutCharactersCharacterIDContactsParamsWithTimeout(timeout time.Duration) *PutCharactersCharacterIDContactsParams {
	var (
		datasourceDefault = string("tranquility")
		labelIDDefault    = int64(0)
		watchedDefault    = bool(false)
	)
	return &PutCharactersCharacterIDContactsParams{
		Datasource: &datasourceDefault,
		LabelID:    &labelIDDefault,
		Watched:    &watchedDefault,

		timeout: timeout,
	}
}

// NewPutCharactersCharacterIDContactsParamsWithContext creates a new PutCharactersCharacterIDContactsParams object
// with the default values initialized, and the ability to set a context for a request
func NewPutCharactersCharacterIDContactsParamsWithContext(ctx context.Context) *PutCharactersCharacterIDContactsParams {
	var (
		datasourceDefault = string("tranquility")
		labelIdDefault    = int64(0)
		watchedDefault    = bool(false)
	)
	return &PutCharactersCharacterIDContactsParams{
		Datasource: &datasourceDefault,
		LabelID:    &labelIdDefault,
		Watched:    &watchedDefault,

		Context: ctx,
	}
}

// NewPutCharactersCharacterIDContactsParamsWithHTTPClient creates a new PutCharactersCharacterIDContactsParams object
// with the default values initialized, and the ability to set a custom HTTPClient for a request
func NewPutCharactersCharacterIDContactsParamsWithHTTPClient(client *http.Client) *PutCharactersCharacterIDContactsParams {
	var (
		datasourceDefault = string("tranquility")
		labelIdDefault    = int64(0)
		watchedDefault    = bool(false)
	)
	return &PutCharactersCharacterIDContactsParams{
		Datasource: &datasourceDefault,
		LabelID:    &labelIdDefault,
		Watched:    &watchedDefault,
		HTTPClient: client,
	}
}

/*PutCharactersCharacterIDContactsParams contains all the parameters to send to the API endpoint
for the put characters character id contacts operation typically these are written to a http.Request
*/
type PutCharactersCharacterIDContactsParams struct {

	/*XUserAgent
	  Client identifier, takes precedence over User-Agent

	*/
	XUserAgent *string
	/*CharacterID
	  An EVE character ID

	*/
	CharacterID int32
	/*ContactIds
	  A list of contacts to edit

	*/
	ContactIds []int32
	/*Datasource
	  The server name you would like data from

	*/
	Datasource *string
	/*LabelID
	  Add a custom label to the contact, use 0 for clearing label

	*/
	LabelID *int64
	/*Standing
	  Standing for the contact

	*/
	Standing float32
	/*Token
	  Access token to use if unable to set a header

	*/
	Token *string
	/*UserAgent
	  Client identifier, takes precedence over headers

	*/
	UserAgent *string
	/*Watched
	  Whether the contact should be watched, note this is only effective on characters

	*/
	Watched *bool

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithTimeout adds the timeout to the put characters character id contacts params
func (o *PutCharactersCharacterIDContactsParams) WithTimeout(timeout time.Duration) *PutCharactersCharacterIDContactsParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the put characters character id contacts params
func (o *PutCharactersCharacterIDContactsParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the put characters character id contacts params
func (o *PutCharactersCharacterIDContactsParams) WithContext(ctx context.Context) *PutCharactersCharacterIDContactsParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the put characters character id contacts params
func (o *PutCharactersCharacterIDContactsParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the put characters character id contacts params
func (o *PutCharactersCharacterIDContactsParams) WithHTTPClient(client *http.Client) *PutCharactersCharacterIDContactsParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the put characters character id contacts params
func (o *PutCharactersCharacterIDContactsParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithXUserAgent adds the xUserAgent to the put characters character id contacts params
func (o *PutCharactersCharacterIDContactsParams) WithXUserAgent(xUserAgent *string) *PutCharactersCharacterIDContactsParams {
	o.SetXUserAgent(xUserAgent)
	return o
}

// SetXUserAgent adds the xUserAgent to the put characters character id contacts params
func (o *PutCharactersCharacterIDContactsParams) SetXUserAgent(xUserAgent *string) {
	o.XUserAgent = xUserAgent
}

// WithCharacterID adds the characterID to the put characters character id contacts params
func (o *PutCharactersCharacterIDContactsParams) WithCharacterID(characterID int32) *PutCharactersCharacterIDContactsParams {
	o.SetCharacterID(characterID)
	return o
}

// SetCharacterID adds the characterId to the put characters character id contacts params
func (o *PutCharactersCharacterIDContactsParams) SetCharacterID(characterID int32) {
	o.CharacterID = characterID
}

// WithContactIds adds the contactIds to the put characters character id contacts params
func (o *PutCharactersCharacterIDContactsParams) WithContactIds(contactIds []int32) *PutCharactersCharacterIDContactsParams {
	o.SetContactIds(contactIds)
	return o
}

// SetContactIds adds the contactIds to the put characters character id contacts params
func (o *PutCharactersCharacterIDContactsParams) SetContactIds(contactIds []int32) {
	o.ContactIds = contactIds
}

// WithDatasource adds the datasource to the put characters character id contacts params
func (o *PutCharactersCharacterIDContactsParams) WithDatasource(datasource *string) *PutCharactersCharacterIDContactsParams {
	o.SetDatasource(datasource)
	return o
}

// SetDatasource adds the datasource to the put characters character id contacts params
func (o *PutCharactersCharacterIDContactsParams) SetDatasource(datasource *string) {
	o.Datasource = datasource
}

// WithLabelID adds the labelID to the put characters character id contacts params
func (o *PutCharactersCharacterIDContactsParams) WithLabelID(labelID *int64) *PutCharactersCharacterIDContactsParams {
	o.SetLabelID(labelID)
	return o
}

// SetLabelID adds the labelId to the put characters character id contacts params
func (o *PutCharactersCharacterIDContactsParams) SetLabelID(labelID *int64) {
	o.LabelID = labelID
}

// WithStanding adds the standing to the put characters character id contacts params
func (o *PutCharactersCharacterIDContactsParams) WithStanding(standing float32) *PutCharactersCharacterIDContactsParams {
	o.SetStanding(standing)
	return o
}

// SetStanding adds the standing to the put characters character id contacts params
func (o *PutCharactersCharacterIDContactsParams) SetStanding(standing float32) {
	o.Standing = standing
}

// WithToken adds the token to the put characters character id contacts params
func (o *PutCharactersCharacterIDContactsParams) WithToken(token *string) *PutCharactersCharacterIDContactsParams {
	o.SetToken(token)
	return o
}

// SetToken adds the token to the put characters character id contacts params
func (o *PutCharactersCharacterIDContactsParams) SetToken(token *string) {
	o.Token = token
}

// WithUserAgent adds the userAgent to the put characters character id contacts params
func (o *PutCharactersCharacterIDContactsParams) WithUserAgent(userAgent *string) *PutCharactersCharacterIDContactsParams {
	o.SetUserAgent(userAgent)
	return o
}

// SetUserAgent adds the userAgent to the put characters character id contacts params
func (o *PutCharactersCharacterIDContactsParams) SetUserAgent(userAgent *string) {
	o.UserAgent = userAgent
}

// WithWatched adds the watched to the put characters character id contacts params
func (o *PutCharactersCharacterIDContactsParams) WithWatched(watched *bool) *PutCharactersCharacterIDContactsParams {
	o.SetWatched(watched)
	return o
}

// SetWatched adds the watched to the put characters character id contacts params
func (o *PutCharactersCharacterIDContactsParams) SetWatched(watched *bool) {
	o.Watched = watched
}

// WriteToRequest writes these params to a swagger request
func (o *PutCharactersCharacterIDContactsParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error

	if o.XUserAgent != nil {

		// header param X-User-Agent
		if err := r.SetHeaderParam("X-User-Agent", *o.XUserAgent); err != nil {
			return err
		}

	}

	// path param character_id
	if err := r.SetPathParam("character_id", swag.FormatInt32(o.CharacterID)); err != nil {
		return err
	}

	if err := r.SetBodyParam(o.ContactIds); err != nil {
		return err
	}

	if o.Datasource != nil {

		// query param datasource
		var qrDatasource string
		if o.Datasource != nil {
			qrDatasource = *o.Datasource
		}
		qDatasource := qrDatasource
		if qDatasource != "" {
			if err := r.SetQueryParam("datasource", qDatasource); err != nil {
				return err
			}
		}

	}

	if o.LabelID != nil {

		// query param label_id
		var qrLabelID int64
		if o.LabelID != nil {
			qrLabelID = *o.LabelID
		}
		qLabelID := swag.FormatInt64(qrLabelID)
		if qLabelID != "" {
			if err := r.SetQueryParam("label_id", qLabelID); err != nil {
				return err
			}
		}

	}

	// query param standing
	qrStanding := o.Standing
	qStanding := swag.FormatFloat32(qrStanding)
	if qStanding != "" {
		if err := r.SetQueryParam("standing", qStanding); err != nil {
			return err
		}
	}

	if o.Token != nil {

		// query param token
		var qrToken string
		if o.Token != nil {
			qrToken = *o.Token
		}
		qToken := qrToken
		if qToken != "" {
			if err := r.SetQueryParam("token", qToken); err != nil {
				return err
			}
		}

	}

	if o.UserAgent != nil {

		// query param user_agent
		var qrUserAgent string
		if o.UserAgent != nil {
			qrUserAgent = *o.UserAgent
		}
		qUserAgent := qrUserAgent
		if qUserAgent != "" {
			if err := r.SetQueryParam("user_agent", qUserAgent); err != nil {
				return err
			}
		}

	}

	if o.Watched != nil {

		// query param watched
		var qrWatched bool
		if o.Watched != nil {
			qrWatched = *o.Watched
		}
		qWatched := swag.FormatBool(qrWatched)
		if qWatched != "" {
			if err := r.SetQueryParam("watched", qWatched); err != nil {
				return err
			}
		}

	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
