// Code generated by go-swagger; DO NOT EDIT.

package fleets

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"fmt"
	"io"

	"github.com/go-openapi/runtime"

	strfmt "github.com/go-openapi/strfmt"

	"git.inf3.xyz/tschwery/eve-goclient.git/models"
)

// GetFleetsFleetIDMembersReader is a Reader for the GetFleetsFleetIDMembers structure.
type GetFleetsFleetIDMembersReader struct {
	formats strfmt.Registry
}

// ReadResponse reads a server response into the received o.
func (o *GetFleetsFleetIDMembersReader) ReadResponse(response runtime.ClientResponse, consumer runtime.Consumer) (interface{}, error) {
	switch response.Code() {

	case 200:
		result := NewGetFleetsFleetIDMembersOK()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return result, nil

	case 403:
		result := NewGetFleetsFleetIDMembersForbidden()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result

	case 404:
		result := NewGetFleetsFleetIDMembersNotFound()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result

	case 500:
		result := NewGetFleetsFleetIDMembersInternalServerError()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result

	default:
		return nil, runtime.NewAPIError("unknown error", response, response.Code())
	}
}

// NewGetFleetsFleetIDMembersOK creates a GetFleetsFleetIDMembersOK with default headers values
func NewGetFleetsFleetIDMembersOK() *GetFleetsFleetIDMembersOK {
	return &GetFleetsFleetIDMembersOK{}
}

/*GetFleetsFleetIDMembersOK handles this case with default header values.

A list of fleet members
*/
type GetFleetsFleetIDMembersOK struct {
	/*The caching mechanism used
	 */
	CacheControl string
	/*The language used in the response
	 */
	ContentLanguage string
	/*RFC7231 formatted datetime string
	 */
	Expires string
	/*RFC7231 formatted datetime string
	 */
	LastModified string

	Payload models.GetFleetsFleetIDMembersOKBody
}

func (o *GetFleetsFleetIDMembersOK) Error() string {
	return fmt.Sprintf("[GET /fleets/{fleet_id}/members/][%d] getFleetsFleetIdMembersOK  %+v", 200, o.Payload)
}

func (o *GetFleetsFleetIDMembersOK) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// response header Cache-Control
	o.CacheControl = response.GetHeader("Cache-Control")

	// response header Content-Language
	o.ContentLanguage = response.GetHeader("Content-Language")

	// response header Expires
	o.Expires = response.GetHeader("Expires")

	// response header Last-Modified
	o.LastModified = response.GetHeader("Last-Modified")

	// response payload
	if err := consumer.Consume(response.Body(), &o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewGetFleetsFleetIDMembersForbidden creates a GetFleetsFleetIDMembersForbidden with default headers values
func NewGetFleetsFleetIDMembersForbidden() *GetFleetsFleetIDMembersForbidden {
	return &GetFleetsFleetIDMembersForbidden{}
}

/*GetFleetsFleetIDMembersForbidden handles this case with default header values.

Forbidden
*/
type GetFleetsFleetIDMembersForbidden struct {
	Payload *models.Forbidden
}

func (o *GetFleetsFleetIDMembersForbidden) Error() string {
	return fmt.Sprintf("[GET /fleets/{fleet_id}/members/][%d] getFleetsFleetIdMembersForbidden  %+v", 403, o.Payload)
}

func (o *GetFleetsFleetIDMembersForbidden) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(models.Forbidden)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewGetFleetsFleetIDMembersNotFound creates a GetFleetsFleetIDMembersNotFound with default headers values
func NewGetFleetsFleetIDMembersNotFound() *GetFleetsFleetIDMembersNotFound {
	return &GetFleetsFleetIDMembersNotFound{}
}

/*GetFleetsFleetIDMembersNotFound handles this case with default header values.

The fleet does not exist or you don't have access to it
*/
type GetFleetsFleetIDMembersNotFound struct {
	Payload *models.GetFleetsFleetIDMembersNotFoundBody
}

func (o *GetFleetsFleetIDMembersNotFound) Error() string {
	return fmt.Sprintf("[GET /fleets/{fleet_id}/members/][%d] getFleetsFleetIdMembersNotFound  %+v", 404, o.Payload)
}

func (o *GetFleetsFleetIDMembersNotFound) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(models.GetFleetsFleetIDMembersNotFoundBody)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewGetFleetsFleetIDMembersInternalServerError creates a GetFleetsFleetIDMembersInternalServerError with default headers values
func NewGetFleetsFleetIDMembersInternalServerError() *GetFleetsFleetIDMembersInternalServerError {
	return &GetFleetsFleetIDMembersInternalServerError{}
}

/*GetFleetsFleetIDMembersInternalServerError handles this case with default header values.

Internal server error
*/
type GetFleetsFleetIDMembersInternalServerError struct {
	Payload *models.InternalServerError
}

func (o *GetFleetsFleetIDMembersInternalServerError) Error() string {
	return fmt.Sprintf("[GET /fleets/{fleet_id}/members/][%d] getFleetsFleetIdMembersInternalServerError  %+v", 500, o.Payload)
}

func (o *GetFleetsFleetIDMembersInternalServerError) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(models.InternalServerError)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}
