// Code generated by go-swagger; DO NOT EDIT.

package fleets

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"net/http"
	"time"

	"golang.org/x/net/context"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/swag"

	strfmt "github.com/go-openapi/strfmt"
)

// NewGetFleetsFleetIDParams creates a new GetFleetsFleetIDParams object
// with the default values initialized.
func NewGetFleetsFleetIDParams() *GetFleetsFleetIDParams {
	var (
		datasourceDefault = string("tranquility")
	)
	return &GetFleetsFleetIDParams{
		Datasource: &datasourceDefault,

		timeout: cr.DefaultTimeout,
	}
}

// NewGetFleetsFleetIDParamsWithTimeout creates a new GetFleetsFleetIDParams object
// with the default values initialized, and the ability to set a timeout on a request
func NewGetFleetsFleetIDParamsWithTimeout(timeout time.Duration) *GetFleetsFleetIDParams {
	var (
		datasourceDefault = string("tranquility")
	)
	return &GetFleetsFleetIDParams{
		Datasource: &datasourceDefault,

		timeout: timeout,
	}
}

// NewGetFleetsFleetIDParamsWithContext creates a new GetFleetsFleetIDParams object
// with the default values initialized, and the ability to set a context for a request
func NewGetFleetsFleetIDParamsWithContext(ctx context.Context) *GetFleetsFleetIDParams {
	var (
		datasourceDefault = string("tranquility")
	)
	return &GetFleetsFleetIDParams{
		Datasource: &datasourceDefault,

		Context: ctx,
	}
}

// NewGetFleetsFleetIDParamsWithHTTPClient creates a new GetFleetsFleetIDParams object
// with the default values initialized, and the ability to set a custom HTTPClient for a request
func NewGetFleetsFleetIDParamsWithHTTPClient(client *http.Client) *GetFleetsFleetIDParams {
	var (
		datasourceDefault = string("tranquility")
	)
	return &GetFleetsFleetIDParams{
		Datasource: &datasourceDefault,
		HTTPClient: client,
	}
}

/*GetFleetsFleetIDParams contains all the parameters to send to the API endpoint
for the get fleets fleet id operation typically these are written to a http.Request
*/
type GetFleetsFleetIDParams struct {

	/*XUserAgent
	  Client identifier, takes precedence over User-Agent

	*/
	XUserAgent *string
	/*Datasource
	  The server name you would like data from

	*/
	Datasource *string
	/*FleetID
	  ID for a fleet

	*/
	FleetID int64
	/*Token
	  Access token to use if unable to set a header

	*/
	Token *string
	/*UserAgent
	  Client identifier, takes precedence over headers

	*/
	UserAgent *string

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithTimeout adds the timeout to the get fleets fleet id params
func (o *GetFleetsFleetIDParams) WithTimeout(timeout time.Duration) *GetFleetsFleetIDParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the get fleets fleet id params
func (o *GetFleetsFleetIDParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the get fleets fleet id params
func (o *GetFleetsFleetIDParams) WithContext(ctx context.Context) *GetFleetsFleetIDParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the get fleets fleet id params
func (o *GetFleetsFleetIDParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the get fleets fleet id params
func (o *GetFleetsFleetIDParams) WithHTTPClient(client *http.Client) *GetFleetsFleetIDParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the get fleets fleet id params
func (o *GetFleetsFleetIDParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithXUserAgent adds the xUserAgent to the get fleets fleet id params
func (o *GetFleetsFleetIDParams) WithXUserAgent(xUserAgent *string) *GetFleetsFleetIDParams {
	o.SetXUserAgent(xUserAgent)
	return o
}

// SetXUserAgent adds the xUserAgent to the get fleets fleet id params
func (o *GetFleetsFleetIDParams) SetXUserAgent(xUserAgent *string) {
	o.XUserAgent = xUserAgent
}

// WithDatasource adds the datasource to the get fleets fleet id params
func (o *GetFleetsFleetIDParams) WithDatasource(datasource *string) *GetFleetsFleetIDParams {
	o.SetDatasource(datasource)
	return o
}

// SetDatasource adds the datasource to the get fleets fleet id params
func (o *GetFleetsFleetIDParams) SetDatasource(datasource *string) {
	o.Datasource = datasource
}

// WithFleetID adds the fleetID to the get fleets fleet id params
func (o *GetFleetsFleetIDParams) WithFleetID(fleetID int64) *GetFleetsFleetIDParams {
	o.SetFleetID(fleetID)
	return o
}

// SetFleetID adds the fleetId to the get fleets fleet id params
func (o *GetFleetsFleetIDParams) SetFleetID(fleetID int64) {
	o.FleetID = fleetID
}

// WithToken adds the token to the get fleets fleet id params
func (o *GetFleetsFleetIDParams) WithToken(token *string) *GetFleetsFleetIDParams {
	o.SetToken(token)
	return o
}

// SetToken adds the token to the get fleets fleet id params
func (o *GetFleetsFleetIDParams) SetToken(token *string) {
	o.Token = token
}

// WithUserAgent adds the userAgent to the get fleets fleet id params
func (o *GetFleetsFleetIDParams) WithUserAgent(userAgent *string) *GetFleetsFleetIDParams {
	o.SetUserAgent(userAgent)
	return o
}

// SetUserAgent adds the userAgent to the get fleets fleet id params
func (o *GetFleetsFleetIDParams) SetUserAgent(userAgent *string) {
	o.UserAgent = userAgent
}

// WriteToRequest writes these params to a swagger request
func (o *GetFleetsFleetIDParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error

	if o.XUserAgent != nil {

		// header param X-User-Agent
		if err := r.SetHeaderParam("X-User-Agent", *o.XUserAgent); err != nil {
			return err
		}

	}

	if o.Datasource != nil {

		// query param datasource
		var qrDatasource string
		if o.Datasource != nil {
			qrDatasource = *o.Datasource
		}
		qDatasource := qrDatasource
		if qDatasource != "" {
			if err := r.SetQueryParam("datasource", qDatasource); err != nil {
				return err
			}
		}

	}

	// path param fleet_id
	if err := r.SetPathParam("fleet_id", swag.FormatInt64(o.FleetID)); err != nil {
		return err
	}

	if o.Token != nil {

		// query param token
		var qrToken string
		if o.Token != nil {
			qrToken = *o.Token
		}
		qToken := qrToken
		if qToken != "" {
			if err := r.SetQueryParam("token", qToken); err != nil {
				return err
			}
		}

	}

	if o.UserAgent != nil {

		// query param user_agent
		var qrUserAgent string
		if o.UserAgent != nil {
			qrUserAgent = *o.UserAgent
		}
		qUserAgent := qrUserAgent
		if qUserAgent != "" {
			if err := r.SetQueryParam("user_agent", qUserAgent); err != nil {
				return err
			}
		}

	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
