// Code generated by go-swagger; DO NOT EDIT.

package mail

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"net/http"
	"time"

	"golang.org/x/net/context"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/swag"

	strfmt "github.com/go-openapi/strfmt"

	"git.inf3.xyz/tschwery/eve-goclient.git/models"
)

// NewPostCharactersCharacterIDMailParams creates a new PostCharactersCharacterIDMailParams object
// with the default values initialized.
func NewPostCharactersCharacterIDMailParams() *PostCharactersCharacterIDMailParams {
	var (
		datasourceDefault = string("tranquility")
	)
	return &PostCharactersCharacterIDMailParams{
		Datasource: &datasourceDefault,

		timeout: cr.DefaultTimeout,
	}
}

// NewPostCharactersCharacterIDMailParamsWithTimeout creates a new PostCharactersCharacterIDMailParams object
// with the default values initialized, and the ability to set a timeout on a request
func NewPostCharactersCharacterIDMailParamsWithTimeout(timeout time.Duration) *PostCharactersCharacterIDMailParams {
	var (
		datasourceDefault = string("tranquility")
	)
	return &PostCharactersCharacterIDMailParams{
		Datasource: &datasourceDefault,

		timeout: timeout,
	}
}

// NewPostCharactersCharacterIDMailParamsWithContext creates a new PostCharactersCharacterIDMailParams object
// with the default values initialized, and the ability to set a context for a request
func NewPostCharactersCharacterIDMailParamsWithContext(ctx context.Context) *PostCharactersCharacterIDMailParams {
	var (
		datasourceDefault = string("tranquility")
	)
	return &PostCharactersCharacterIDMailParams{
		Datasource: &datasourceDefault,

		Context: ctx,
	}
}

// NewPostCharactersCharacterIDMailParamsWithHTTPClient creates a new PostCharactersCharacterIDMailParams object
// with the default values initialized, and the ability to set a custom HTTPClient for a request
func NewPostCharactersCharacterIDMailParamsWithHTTPClient(client *http.Client) *PostCharactersCharacterIDMailParams {
	var (
		datasourceDefault = string("tranquility")
	)
	return &PostCharactersCharacterIDMailParams{
		Datasource: &datasourceDefault,
		HTTPClient: client,
	}
}

/*PostCharactersCharacterIDMailParams contains all the parameters to send to the API endpoint
for the post characters character id mail operation typically these are written to a http.Request
*/
type PostCharactersCharacterIDMailParams struct {

	/*XUserAgent
	  Client identifier, takes precedence over User-Agent

	*/
	XUserAgent *string
	/*CharacterID
	  An EVE character ID

	*/
	CharacterID int32
	/*Datasource
	  The server name you would like data from

	*/
	Datasource *string
	/*Mail
	  The mail to send

	*/
	Mail *models.PostCharactersCharacterIDMailParamsBody
	/*Token
	  Access token to use if unable to set a header

	*/
	Token *string
	/*UserAgent
	  Client identifier, takes precedence over headers

	*/
	UserAgent *string

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithTimeout adds the timeout to the post characters character id mail params
func (o *PostCharactersCharacterIDMailParams) WithTimeout(timeout time.Duration) *PostCharactersCharacterIDMailParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the post characters character id mail params
func (o *PostCharactersCharacterIDMailParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the post characters character id mail params
func (o *PostCharactersCharacterIDMailParams) WithContext(ctx context.Context) *PostCharactersCharacterIDMailParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the post characters character id mail params
func (o *PostCharactersCharacterIDMailParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the post characters character id mail params
func (o *PostCharactersCharacterIDMailParams) WithHTTPClient(client *http.Client) *PostCharactersCharacterIDMailParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the post characters character id mail params
func (o *PostCharactersCharacterIDMailParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithXUserAgent adds the xUserAgent to the post characters character id mail params
func (o *PostCharactersCharacterIDMailParams) WithXUserAgent(xUserAgent *string) *PostCharactersCharacterIDMailParams {
	o.SetXUserAgent(xUserAgent)
	return o
}

// SetXUserAgent adds the xUserAgent to the post characters character id mail params
func (o *PostCharactersCharacterIDMailParams) SetXUserAgent(xUserAgent *string) {
	o.XUserAgent = xUserAgent
}

// WithCharacterID adds the characterID to the post characters character id mail params
func (o *PostCharactersCharacterIDMailParams) WithCharacterID(characterID int32) *PostCharactersCharacterIDMailParams {
	o.SetCharacterID(characterID)
	return o
}

// SetCharacterID adds the characterId to the post characters character id mail params
func (o *PostCharactersCharacterIDMailParams) SetCharacterID(characterID int32) {
	o.CharacterID = characterID
}

// WithDatasource adds the datasource to the post characters character id mail params
func (o *PostCharactersCharacterIDMailParams) WithDatasource(datasource *string) *PostCharactersCharacterIDMailParams {
	o.SetDatasource(datasource)
	return o
}

// SetDatasource adds the datasource to the post characters character id mail params
func (o *PostCharactersCharacterIDMailParams) SetDatasource(datasource *string) {
	o.Datasource = datasource
}

// WithMail adds the mail to the post characters character id mail params
func (o *PostCharactersCharacterIDMailParams) WithMail(mail *models.PostCharactersCharacterIDMailParamsBody) *PostCharactersCharacterIDMailParams {
	o.SetMail(mail)
	return o
}

// SetMail adds the mail to the post characters character id mail params
func (o *PostCharactersCharacterIDMailParams) SetMail(mail *models.PostCharactersCharacterIDMailParamsBody) {
	o.Mail = mail
}

// WithToken adds the token to the post characters character id mail params
func (o *PostCharactersCharacterIDMailParams) WithToken(token *string) *PostCharactersCharacterIDMailParams {
	o.SetToken(token)
	return o
}

// SetToken adds the token to the post characters character id mail params
func (o *PostCharactersCharacterIDMailParams) SetToken(token *string) {
	o.Token = token
}

// WithUserAgent adds the userAgent to the post characters character id mail params
func (o *PostCharactersCharacterIDMailParams) WithUserAgent(userAgent *string) *PostCharactersCharacterIDMailParams {
	o.SetUserAgent(userAgent)
	return o
}

// SetUserAgent adds the userAgent to the post characters character id mail params
func (o *PostCharactersCharacterIDMailParams) SetUserAgent(userAgent *string) {
	o.UserAgent = userAgent
}

// WriteToRequest writes these params to a swagger request
func (o *PostCharactersCharacterIDMailParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error

	if o.XUserAgent != nil {

		// header param X-User-Agent
		if err := r.SetHeaderParam("X-User-Agent", *o.XUserAgent); err != nil {
			return err
		}

	}

	// path param character_id
	if err := r.SetPathParam("character_id", swag.FormatInt32(o.CharacterID)); err != nil {
		return err
	}

	if o.Datasource != nil {

		// query param datasource
		var qrDatasource string
		if o.Datasource != nil {
			qrDatasource = *o.Datasource
		}
		qDatasource := qrDatasource
		if qDatasource != "" {
			if err := r.SetQueryParam("datasource", qDatasource); err != nil {
				return err
			}
		}

	}

	if o.Mail == nil {
		o.Mail = new(models.PostCharactersCharacterIDMailParamsBody)
	}

	if err := r.SetBodyParam(o.Mail); err != nil {
		return err
	}

	if o.Token != nil {

		// query param token
		var qrToken string
		if o.Token != nil {
			qrToken = *o.Token
		}
		qToken := qrToken
		if qToken != "" {
			if err := r.SetQueryParam("token", qToken); err != nil {
				return err
			}
		}

	}

	if o.UserAgent != nil {

		// query param user_agent
		var qrUserAgent string
		if o.UserAgent != nil {
			qrUserAgent = *o.UserAgent
		}
		qUserAgent := qrUserAgent
		if qUserAgent != "" {
			if err := r.SetQueryParam("user_agent", qUserAgent); err != nil {
				return err
			}
		}

	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
