// Code generated by go-swagger; DO NOT EDIT.

package planetary_interaction

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"github.com/go-openapi/runtime"

	strfmt "github.com/go-openapi/strfmt"
)

// New creates a new planetary interaction API client.
func New(transport runtime.ClientTransport, formats strfmt.Registry) *Client {
	return &Client{transport: transport, formats: formats}
}

/*
Client for planetary interaction API
*/
type Client struct {
	transport runtime.ClientTransport
	formats   strfmt.Registry
}

/*
GetCharactersCharacterIDPlanets gets colonies

Returns a list of all planetary colonies owned by a character.

---
Alternate route: `/v1/characters/{character_id}/planets/`

Alternate route: `/legacy/characters/{character_id}/planets/`

Alternate route: `/dev/characters/{character_id}/planets/`

---
This route is cached for up to 600 seconds
*/
func (a *Client) GetCharactersCharacterIDPlanets(params *GetCharactersCharacterIDPlanetsParams, authInfo runtime.ClientAuthInfoWriter) (*GetCharactersCharacterIDPlanetsOK, error) {
	// TODO: Validate the params before sending
	if params == nil {
		params = NewGetCharactersCharacterIDPlanetsParams()
	}

	result, err := a.transport.Submit(&runtime.ClientOperation{
		ID:                 "get_characters_character_id_planets",
		Method:             "GET",
		PathPattern:        "/characters/{character_id}/planets/",
		ProducesMediaTypes: []string{"application/json"},
		ConsumesMediaTypes: []string{""},
		Schemes:            []string{"https"},
		Params:             params,
		Reader:             &GetCharactersCharacterIDPlanetsReader{formats: a.formats},
		AuthInfo:           authInfo,
		Context:            params.Context,
		Client:             params.HTTPClient,
	})
	if err != nil {
		return nil, err
	}
	return result.(*GetCharactersCharacterIDPlanetsOK), nil

}

/*
GetCharactersCharacterIDPlanetsPlanetID gets colony layout

Returns full details on the layout of a single planetary colony, including links, pins and routes. Note: Planetary information is only recalculated when the colony is viewed through the client. Information will not update until this criteria is met.

---
Alternate route: `/v3/characters/{character_id}/planets/{planet_id}/`

Alternate route: `/dev/characters/{character_id}/planets/{planet_id}/`

---
This route is cached for up to 600 seconds
*/
func (a *Client) GetCharactersCharacterIDPlanetsPlanetID(params *GetCharactersCharacterIDPlanetsPlanetIDParams, authInfo runtime.ClientAuthInfoWriter) (*GetCharactersCharacterIDPlanetsPlanetIDOK, error) {
	// TODO: Validate the params before sending
	if params == nil {
		params = NewGetCharactersCharacterIDPlanetsPlanetIDParams()
	}

	result, err := a.transport.Submit(&runtime.ClientOperation{
		ID:                 "get_characters_character_id_planets_planet_id",
		Method:             "GET",
		PathPattern:        "/characters/{character_id}/planets/{planet_id}/",
		ProducesMediaTypes: []string{"application/json"},
		ConsumesMediaTypes: []string{""},
		Schemes:            []string{"https"},
		Params:             params,
		Reader:             &GetCharactersCharacterIDPlanetsPlanetIDReader{formats: a.formats},
		AuthInfo:           authInfo,
		Context:            params.Context,
		Client:             params.HTTPClient,
	})
	if err != nil {
		return nil, err
	}
	return result.(*GetCharactersCharacterIDPlanetsPlanetIDOK), nil

}

/*
GetUniverseSchematicsSchematicID gets schematic information

Get information on a planetary factory schematic

---
Alternate route: `/v1/universe/schematics/{schematic_id}/`

Alternate route: `/legacy/universe/schematics/{schematic_id}/`

Alternate route: `/dev/universe/schematics/{schematic_id}/`

---
This route is cached for up to 3600 seconds
*/
func (a *Client) GetUniverseSchematicsSchematicID(params *GetUniverseSchematicsSchematicIDParams) (*GetUniverseSchematicsSchematicIDOK, error) {
	// TODO: Validate the params before sending
	if params == nil {
		params = NewGetUniverseSchematicsSchematicIDParams()
	}

	result, err := a.transport.Submit(&runtime.ClientOperation{
		ID:                 "get_universe_schematics_schematic_id",
		Method:             "GET",
		PathPattern:        "/universe/schematics/{schematic_id}/",
		ProducesMediaTypes: []string{"application/json"},
		ConsumesMediaTypes: []string{""},
		Schemes:            []string{"https"},
		Params:             params,
		Reader:             &GetUniverseSchematicsSchematicIDReader{formats: a.formats},
		Context:            params.Context,
		Client:             params.HTTPClient,
	})
	if err != nil {
		return nil, err
	}
	return result.(*GetUniverseSchematicsSchematicIDOK), nil

}

// SetTransport changes the transport on the client
func (a *Client) SetTransport(transport runtime.ClientTransport) {
	a.transport = transport
}
