// Code generated by go-swagger; DO NOT EDIT.

package sovereignty

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"github.com/go-openapi/runtime"

	strfmt "github.com/go-openapi/strfmt"
)

// New creates a new sovereignty API client.
func New(transport runtime.ClientTransport, formats strfmt.Registry) *Client {
	return &Client{transport: transport, formats: formats}
}

/*
Client for sovereignty API
*/
type Client struct {
	transport runtime.ClientTransport
	formats   strfmt.Registry
}

/*
GetSovereigntyCampaigns lists sovereignty campaigns

Shows sovereignty data for campaigns.

---
Alternate route: `/v1/sovereignty/campaigns/`

Alternate route: `/legacy/sovereignty/campaigns/`

Alternate route: `/dev/sovereignty/campaigns/`

---
This route is cached for up to 5 seconds
*/
func (a *Client) GetSovereigntyCampaigns(params *GetSovereigntyCampaignsParams) (*GetSovereigntyCampaignsOK, error) {
	// TODO: Validate the params before sending
	if params == nil {
		params = NewGetSovereigntyCampaignsParams()
	}

	result, err := a.transport.Submit(&runtime.ClientOperation{
		ID:                 "get_sovereignty_campaigns",
		Method:             "GET",
		PathPattern:        "/sovereignty/campaigns/",
		ProducesMediaTypes: []string{"application/json"},
		ConsumesMediaTypes: []string{""},
		Schemes:            []string{"https"},
		Params:             params,
		Reader:             &GetSovereigntyCampaignsReader{formats: a.formats},
		Context:            params.Context,
		Client:             params.HTTPClient,
	})
	if err != nil {
		return nil, err
	}
	return result.(*GetSovereigntyCampaignsOK), nil

}

/*
GetSovereigntyMap lists sovereignty of systems

Shows sovereignty information for solar systems

---
Alternate route: `/v1/sovereignty/map/`

Alternate route: `/legacy/sovereignty/map/`

Alternate route: `/dev/sovereignty/map/`

---
This route is cached for up to 3600 seconds
*/
func (a *Client) GetSovereigntyMap(params *GetSovereigntyMapParams) (*GetSovereigntyMapOK, error) {
	// TODO: Validate the params before sending
	if params == nil {
		params = NewGetSovereigntyMapParams()
	}

	result, err := a.transport.Submit(&runtime.ClientOperation{
		ID:                 "get_sovereignty_map",
		Method:             "GET",
		PathPattern:        "/sovereignty/map/",
		ProducesMediaTypes: []string{"application/json"},
		ConsumesMediaTypes: []string{""},
		Schemes:            []string{"https"},
		Params:             params,
		Reader:             &GetSovereigntyMapReader{formats: a.formats},
		Context:            params.Context,
		Client:             params.HTTPClient,
	})
	if err != nil {
		return nil, err
	}
	return result.(*GetSovereigntyMapOK), nil

}

/*
GetSovereigntyStructures lists sovereignty structures

Shows sovereignty data for structures.

---
Alternate route: `/v1/sovereignty/structures/`

Alternate route: `/legacy/sovereignty/structures/`

Alternate route: `/dev/sovereignty/structures/`

---
This route is cached for up to 120 seconds
*/
func (a *Client) GetSovereigntyStructures(params *GetSovereigntyStructuresParams) (*GetSovereigntyStructuresOK, error) {
	// TODO: Validate the params before sending
	if params == nil {
		params = NewGetSovereigntyStructuresParams()
	}

	result, err := a.transport.Submit(&runtime.ClientOperation{
		ID:                 "get_sovereignty_structures",
		Method:             "GET",
		PathPattern:        "/sovereignty/structures/",
		ProducesMediaTypes: []string{"application/json"},
		ConsumesMediaTypes: []string{""},
		Schemes:            []string{"https"},
		Params:             params,
		Reader:             &GetSovereigntyStructuresReader{formats: a.formats},
		Context:            params.Context,
		Client:             params.HTTPClient,
	})
	if err != nil {
		return nil, err
	}
	return result.(*GetSovereigntyStructuresOK), nil

}

// SetTransport changes the transport on the client
func (a *Client) SetTransport(transport runtime.ClientTransport) {
	a.transport = transport
}
