// Code generated by go-swagger; DO NOT EDIT.

package universe

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"net/http"
	"time"

	"golang.org/x/net/context"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"

	strfmt "github.com/go-openapi/strfmt"
)

// NewGetUniverseBloodlinesParams creates a new GetUniverseBloodlinesParams object
// with the default values initialized.
func NewGetUniverseBloodlinesParams() *GetUniverseBloodlinesParams {
	var (
		datasourceDefault = string("tranquility")
		languageDefault   = string("en-us")
	)
	return &GetUniverseBloodlinesParams{
		Datasource: &datasourceDefault,
		Language:   &languageDefault,

		timeout: cr.DefaultTimeout,
	}
}

// NewGetUniverseBloodlinesParamsWithTimeout creates a new GetUniverseBloodlinesParams object
// with the default values initialized, and the ability to set a timeout on a request
func NewGetUniverseBloodlinesParamsWithTimeout(timeout time.Duration) *GetUniverseBloodlinesParams {
	var (
		datasourceDefault = string("tranquility")
		languageDefault   = string("en-us")
	)
	return &GetUniverseBloodlinesParams{
		Datasource: &datasourceDefault,
		Language:   &languageDefault,

		timeout: timeout,
	}
}

// NewGetUniverseBloodlinesParamsWithContext creates a new GetUniverseBloodlinesParams object
// with the default values initialized, and the ability to set a context for a request
func NewGetUniverseBloodlinesParamsWithContext(ctx context.Context) *GetUniverseBloodlinesParams {
	var (
		datasourceDefault = string("tranquility")
		languageDefault   = string("en-us")
	)
	return &GetUniverseBloodlinesParams{
		Datasource: &datasourceDefault,
		Language:   &languageDefault,

		Context: ctx,
	}
}

// NewGetUniverseBloodlinesParamsWithHTTPClient creates a new GetUniverseBloodlinesParams object
// with the default values initialized, and the ability to set a custom HTTPClient for a request
func NewGetUniverseBloodlinesParamsWithHTTPClient(client *http.Client) *GetUniverseBloodlinesParams {
	var (
		datasourceDefault = string("tranquility")
		languageDefault   = string("en-us")
	)
	return &GetUniverseBloodlinesParams{
		Datasource: &datasourceDefault,
		Language:   &languageDefault,
		HTTPClient: client,
	}
}

/*GetUniverseBloodlinesParams contains all the parameters to send to the API endpoint
for the get universe bloodlines operation typically these are written to a http.Request
*/
type GetUniverseBloodlinesParams struct {

	/*XUserAgent
	  Client identifier, takes precedence over User-Agent

	*/
	XUserAgent *string
	/*Datasource
	  The server name you would like data from

	*/
	Datasource *string
	/*Language
	  Language to use in the response

	*/
	Language *string
	/*UserAgent
	  Client identifier, takes precedence over headers

	*/
	UserAgent *string

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithTimeout adds the timeout to the get universe bloodlines params
func (o *GetUniverseBloodlinesParams) WithTimeout(timeout time.Duration) *GetUniverseBloodlinesParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the get universe bloodlines params
func (o *GetUniverseBloodlinesParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the get universe bloodlines params
func (o *GetUniverseBloodlinesParams) WithContext(ctx context.Context) *GetUniverseBloodlinesParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the get universe bloodlines params
func (o *GetUniverseBloodlinesParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the get universe bloodlines params
func (o *GetUniverseBloodlinesParams) WithHTTPClient(client *http.Client) *GetUniverseBloodlinesParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the get universe bloodlines params
func (o *GetUniverseBloodlinesParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithXUserAgent adds the xUserAgent to the get universe bloodlines params
func (o *GetUniverseBloodlinesParams) WithXUserAgent(xUserAgent *string) *GetUniverseBloodlinesParams {
	o.SetXUserAgent(xUserAgent)
	return o
}

// SetXUserAgent adds the xUserAgent to the get universe bloodlines params
func (o *GetUniverseBloodlinesParams) SetXUserAgent(xUserAgent *string) {
	o.XUserAgent = xUserAgent
}

// WithDatasource adds the datasource to the get universe bloodlines params
func (o *GetUniverseBloodlinesParams) WithDatasource(datasource *string) *GetUniverseBloodlinesParams {
	o.SetDatasource(datasource)
	return o
}

// SetDatasource adds the datasource to the get universe bloodlines params
func (o *GetUniverseBloodlinesParams) SetDatasource(datasource *string) {
	o.Datasource = datasource
}

// WithLanguage adds the language to the get universe bloodlines params
func (o *GetUniverseBloodlinesParams) WithLanguage(language *string) *GetUniverseBloodlinesParams {
	o.SetLanguage(language)
	return o
}

// SetLanguage adds the language to the get universe bloodlines params
func (o *GetUniverseBloodlinesParams) SetLanguage(language *string) {
	o.Language = language
}

// WithUserAgent adds the userAgent to the get universe bloodlines params
func (o *GetUniverseBloodlinesParams) WithUserAgent(userAgent *string) *GetUniverseBloodlinesParams {
	o.SetUserAgent(userAgent)
	return o
}

// SetUserAgent adds the userAgent to the get universe bloodlines params
func (o *GetUniverseBloodlinesParams) SetUserAgent(userAgent *string) {
	o.UserAgent = userAgent
}

// WriteToRequest writes these params to a swagger request
func (o *GetUniverseBloodlinesParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error

	if o.XUserAgent != nil {

		// header param X-User-Agent
		if err := r.SetHeaderParam("X-User-Agent", *o.XUserAgent); err != nil {
			return err
		}

	}

	if o.Datasource != nil {

		// query param datasource
		var qrDatasource string
		if o.Datasource != nil {
			qrDatasource = *o.Datasource
		}
		qDatasource := qrDatasource
		if qDatasource != "" {
			if err := r.SetQueryParam("datasource", qDatasource); err != nil {
				return err
			}
		}

	}

	if o.Language != nil {

		// query param language
		var qrLanguage string
		if o.Language != nil {
			qrLanguage = *o.Language
		}
		qLanguage := qrLanguage
		if qLanguage != "" {
			if err := r.SetQueryParam("language", qLanguage); err != nil {
				return err
			}
		}

	}

	if o.UserAgent != nil {

		// query param user_agent
		var qrUserAgent string
		if o.UserAgent != nil {
			qrUserAgent = *o.UserAgent
		}
		qUserAgent := qrUserAgent
		if qUserAgent != "" {
			if err := r.SetQueryParam("user_agent", qUserAgent); err != nil {
				return err
			}
		}

	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
