// Code generated by go-swagger; DO NOT EDIT.

package universe

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"net/http"
	"time"

	"golang.org/x/net/context"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"

	strfmt "github.com/go-openapi/strfmt"
)

// NewGetUniverseRacesParams creates a new GetUniverseRacesParams object
// with the default values initialized.
func NewGetUniverseRacesParams() *GetUniverseRacesParams {
	var (
		datasourceDefault = string("tranquility")
		languageDefault   = string("en-us")
	)
	return &GetUniverseRacesParams{
		Datasource: &datasourceDefault,
		Language:   &languageDefault,

		timeout: cr.DefaultTimeout,
	}
}

// NewGetUniverseRacesParamsWithTimeout creates a new GetUniverseRacesParams object
// with the default values initialized, and the ability to set a timeout on a request
func NewGetUniverseRacesParamsWithTimeout(timeout time.Duration) *GetUniverseRacesParams {
	var (
		datasourceDefault = string("tranquility")
		languageDefault   = string("en-us")
	)
	return &GetUniverseRacesParams{
		Datasource: &datasourceDefault,
		Language:   &languageDefault,

		timeout: timeout,
	}
}

// NewGetUniverseRacesParamsWithContext creates a new GetUniverseRacesParams object
// with the default values initialized, and the ability to set a context for a request
func NewGetUniverseRacesParamsWithContext(ctx context.Context) *GetUniverseRacesParams {
	var (
		datasourceDefault = string("tranquility")
		languageDefault   = string("en-us")
	)
	return &GetUniverseRacesParams{
		Datasource: &datasourceDefault,
		Language:   &languageDefault,

		Context: ctx,
	}
}

// NewGetUniverseRacesParamsWithHTTPClient creates a new GetUniverseRacesParams object
// with the default values initialized, and the ability to set a custom HTTPClient for a request
func NewGetUniverseRacesParamsWithHTTPClient(client *http.Client) *GetUniverseRacesParams {
	var (
		datasourceDefault = string("tranquility")
		languageDefault   = string("en-us")
	)
	return &GetUniverseRacesParams{
		Datasource: &datasourceDefault,
		Language:   &languageDefault,
		HTTPClient: client,
	}
}

/*GetUniverseRacesParams contains all the parameters to send to the API endpoint
for the get universe races operation typically these are written to a http.Request
*/
type GetUniverseRacesParams struct {

	/*XUserAgent
	  Client identifier, takes precedence over User-Agent

	*/
	XUserAgent *string
	/*Datasource
	  The server name you would like data from

	*/
	Datasource *string
	/*Language
	  Language to use in the response

	*/
	Language *string
	/*UserAgent
	  Client identifier, takes precedence over headers

	*/
	UserAgent *string

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithTimeout adds the timeout to the get universe races params
func (o *GetUniverseRacesParams) WithTimeout(timeout time.Duration) *GetUniverseRacesParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the get universe races params
func (o *GetUniverseRacesParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the get universe races params
func (o *GetUniverseRacesParams) WithContext(ctx context.Context) *GetUniverseRacesParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the get universe races params
func (o *GetUniverseRacesParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the get universe races params
func (o *GetUniverseRacesParams) WithHTTPClient(client *http.Client) *GetUniverseRacesParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the get universe races params
func (o *GetUniverseRacesParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithXUserAgent adds the xUserAgent to the get universe races params
func (o *GetUniverseRacesParams) WithXUserAgent(xUserAgent *string) *GetUniverseRacesParams {
	o.SetXUserAgent(xUserAgent)
	return o
}

// SetXUserAgent adds the xUserAgent to the get universe races params
func (o *GetUniverseRacesParams) SetXUserAgent(xUserAgent *string) {
	o.XUserAgent = xUserAgent
}

// WithDatasource adds the datasource to the get universe races params
func (o *GetUniverseRacesParams) WithDatasource(datasource *string) *GetUniverseRacesParams {
	o.SetDatasource(datasource)
	return o
}

// SetDatasource adds the datasource to the get universe races params
func (o *GetUniverseRacesParams) SetDatasource(datasource *string) {
	o.Datasource = datasource
}

// WithLanguage adds the language to the get universe races params
func (o *GetUniverseRacesParams) WithLanguage(language *string) *GetUniverseRacesParams {
	o.SetLanguage(language)
	return o
}

// SetLanguage adds the language to the get universe races params
func (o *GetUniverseRacesParams) SetLanguage(language *string) {
	o.Language = language
}

// WithUserAgent adds the userAgent to the get universe races params
func (o *GetUniverseRacesParams) WithUserAgent(userAgent *string) *GetUniverseRacesParams {
	o.SetUserAgent(userAgent)
	return o
}

// SetUserAgent adds the userAgent to the get universe races params
func (o *GetUniverseRacesParams) SetUserAgent(userAgent *string) {
	o.UserAgent = userAgent
}

// WriteToRequest writes these params to a swagger request
func (o *GetUniverseRacesParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error

	if o.XUserAgent != nil {

		// header param X-User-Agent
		if err := r.SetHeaderParam("X-User-Agent", *o.XUserAgent); err != nil {
			return err
		}

	}

	if o.Datasource != nil {

		// query param datasource
		var qrDatasource string
		if o.Datasource != nil {
			qrDatasource = *o.Datasource
		}
		qDatasource := qrDatasource
		if qDatasource != "" {
			if err := r.SetQueryParam("datasource", qDatasource); err != nil {
				return err
			}
		}

	}

	if o.Language != nil {

		// query param language
		var qrLanguage string
		if o.Language != nil {
			qrLanguage = *o.Language
		}
		qLanguage := qrLanguage
		if qLanguage != "" {
			if err := r.SetQueryParam("language", qLanguage); err != nil {
				return err
			}
		}

	}

	if o.UserAgent != nil {

		// query param user_agent
		var qrUserAgent string
		if o.UserAgent != nil {
			qrUserAgent = *o.UserAgent
		}
		qUserAgent := qrUserAgent
		if qUserAgent != "" {
			if err := r.SetQueryParam("user_agent", qUserAgent); err != nil {
				return err
			}
		}

	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
