// Code generated by go-swagger; DO NOT EDIT.

package universe

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"net/http"
	"time"

	"golang.org/x/net/context"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"

	strfmt "github.com/go-openapi/strfmt"
)

// NewGetUniverseRegionsParams creates a new GetUniverseRegionsParams object
// with the default values initialized.
func NewGetUniverseRegionsParams() *GetUniverseRegionsParams {
	var (
		datasourceDefault = string("tranquility")
	)
	return &GetUniverseRegionsParams{
		Datasource: &datasourceDefault,

		timeout: cr.DefaultTimeout,
	}
}

// NewGetUniverseRegionsParamsWithTimeout creates a new GetUniverseRegionsParams object
// with the default values initialized, and the ability to set a timeout on a request
func NewGetUniverseRegionsParamsWithTimeout(timeout time.Duration) *GetUniverseRegionsParams {
	var (
		datasourceDefault = string("tranquility")
	)
	return &GetUniverseRegionsParams{
		Datasource: &datasourceDefault,

		timeout: timeout,
	}
}

// NewGetUniverseRegionsParamsWithContext creates a new GetUniverseRegionsParams object
// with the default values initialized, and the ability to set a context for a request
func NewGetUniverseRegionsParamsWithContext(ctx context.Context) *GetUniverseRegionsParams {
	var (
		datasourceDefault = string("tranquility")
	)
	return &GetUniverseRegionsParams{
		Datasource: &datasourceDefault,

		Context: ctx,
	}
}

// NewGetUniverseRegionsParamsWithHTTPClient creates a new GetUniverseRegionsParams object
// with the default values initialized, and the ability to set a custom HTTPClient for a request
func NewGetUniverseRegionsParamsWithHTTPClient(client *http.Client) *GetUniverseRegionsParams {
	var (
		datasourceDefault = string("tranquility")
	)
	return &GetUniverseRegionsParams{
		Datasource: &datasourceDefault,
		HTTPClient: client,
	}
}

/*GetUniverseRegionsParams contains all the parameters to send to the API endpoint
for the get universe regions operation typically these are written to a http.Request
*/
type GetUniverseRegionsParams struct {

	/*XUserAgent
	  Client identifier, takes precedence over User-Agent

	*/
	XUserAgent *string
	/*Datasource
	  The server name you would like data from

	*/
	Datasource *string
	/*UserAgent
	  Client identifier, takes precedence over headers

	*/
	UserAgent *string

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithTimeout adds the timeout to the get universe regions params
func (o *GetUniverseRegionsParams) WithTimeout(timeout time.Duration) *GetUniverseRegionsParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the get universe regions params
func (o *GetUniverseRegionsParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the get universe regions params
func (o *GetUniverseRegionsParams) WithContext(ctx context.Context) *GetUniverseRegionsParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the get universe regions params
func (o *GetUniverseRegionsParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the get universe regions params
func (o *GetUniverseRegionsParams) WithHTTPClient(client *http.Client) *GetUniverseRegionsParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the get universe regions params
func (o *GetUniverseRegionsParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithXUserAgent adds the xUserAgent to the get universe regions params
func (o *GetUniverseRegionsParams) WithXUserAgent(xUserAgent *string) *GetUniverseRegionsParams {
	o.SetXUserAgent(xUserAgent)
	return o
}

// SetXUserAgent adds the xUserAgent to the get universe regions params
func (o *GetUniverseRegionsParams) SetXUserAgent(xUserAgent *string) {
	o.XUserAgent = xUserAgent
}

// WithDatasource adds the datasource to the get universe regions params
func (o *GetUniverseRegionsParams) WithDatasource(datasource *string) *GetUniverseRegionsParams {
	o.SetDatasource(datasource)
	return o
}

// SetDatasource adds the datasource to the get universe regions params
func (o *GetUniverseRegionsParams) SetDatasource(datasource *string) {
	o.Datasource = datasource
}

// WithUserAgent adds the userAgent to the get universe regions params
func (o *GetUniverseRegionsParams) WithUserAgent(userAgent *string) *GetUniverseRegionsParams {
	o.SetUserAgent(userAgent)
	return o
}

// SetUserAgent adds the userAgent to the get universe regions params
func (o *GetUniverseRegionsParams) SetUserAgent(userAgent *string) {
	o.UserAgent = userAgent
}

// WriteToRequest writes these params to a swagger request
func (o *GetUniverseRegionsParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error

	if o.XUserAgent != nil {

		// header param X-User-Agent
		if err := r.SetHeaderParam("X-User-Agent", *o.XUserAgent); err != nil {
			return err
		}

	}

	if o.Datasource != nil {

		// query param datasource
		var qrDatasource string
		if o.Datasource != nil {
			qrDatasource = *o.Datasource
		}
		qDatasource := qrDatasource
		if qDatasource != "" {
			if err := r.SetQueryParam("datasource", qDatasource); err != nil {
				return err
			}
		}

	}

	if o.UserAgent != nil {

		// query param user_agent
		var qrUserAgent string
		if o.UserAgent != nil {
			qrUserAgent = *o.UserAgent
		}
		qUserAgent := qrUserAgent
		if qUserAgent != "" {
			if err := r.SetQueryParam("user_agent", qUserAgent); err != nil {
				return err
			}
		}

	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
