// Code generated by go-swagger; DO NOT EDIT.

package universe

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"net/http"
	"time"

	"golang.org/x/net/context"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/swag"

	strfmt "github.com/go-openapi/strfmt"
)

// NewGetUniverseStarsStarIDParams creates a new GetUniverseStarsStarIDParams object
// with the default values initialized.
func NewGetUniverseStarsStarIDParams() *GetUniverseStarsStarIDParams {
	var (
		datasourceDefault = string("tranquility")
	)
	return &GetUniverseStarsStarIDParams{
		Datasource: &datasourceDefault,

		timeout: cr.DefaultTimeout,
	}
}

// NewGetUniverseStarsStarIDParamsWithTimeout creates a new GetUniverseStarsStarIDParams object
// with the default values initialized, and the ability to set a timeout on a request
func NewGetUniverseStarsStarIDParamsWithTimeout(timeout time.Duration) *GetUniverseStarsStarIDParams {
	var (
		datasourceDefault = string("tranquility")
	)
	return &GetUniverseStarsStarIDParams{
		Datasource: &datasourceDefault,

		timeout: timeout,
	}
}

// NewGetUniverseStarsStarIDParamsWithContext creates a new GetUniverseStarsStarIDParams object
// with the default values initialized, and the ability to set a context for a request
func NewGetUniverseStarsStarIDParamsWithContext(ctx context.Context) *GetUniverseStarsStarIDParams {
	var (
		datasourceDefault = string("tranquility")
	)
	return &GetUniverseStarsStarIDParams{
		Datasource: &datasourceDefault,

		Context: ctx,
	}
}

// NewGetUniverseStarsStarIDParamsWithHTTPClient creates a new GetUniverseStarsStarIDParams object
// with the default values initialized, and the ability to set a custom HTTPClient for a request
func NewGetUniverseStarsStarIDParamsWithHTTPClient(client *http.Client) *GetUniverseStarsStarIDParams {
	var (
		datasourceDefault = string("tranquility")
	)
	return &GetUniverseStarsStarIDParams{
		Datasource: &datasourceDefault,
		HTTPClient: client,
	}
}

/*GetUniverseStarsStarIDParams contains all the parameters to send to the API endpoint
for the get universe stars star id operation typically these are written to a http.Request
*/
type GetUniverseStarsStarIDParams struct {

	/*XUserAgent
	  Client identifier, takes precedence over User-Agent

	*/
	XUserAgent *string
	/*Datasource
	  The server name you would like data from

	*/
	Datasource *string
	/*StarID
	  star_id integer

	*/
	StarID int32
	/*UserAgent
	  Client identifier, takes precedence over headers

	*/
	UserAgent *string

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithTimeout adds the timeout to the get universe stars star id params
func (o *GetUniverseStarsStarIDParams) WithTimeout(timeout time.Duration) *GetUniverseStarsStarIDParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the get universe stars star id params
func (o *GetUniverseStarsStarIDParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the get universe stars star id params
func (o *GetUniverseStarsStarIDParams) WithContext(ctx context.Context) *GetUniverseStarsStarIDParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the get universe stars star id params
func (o *GetUniverseStarsStarIDParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the get universe stars star id params
func (o *GetUniverseStarsStarIDParams) WithHTTPClient(client *http.Client) *GetUniverseStarsStarIDParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the get universe stars star id params
func (o *GetUniverseStarsStarIDParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithXUserAgent adds the xUserAgent to the get universe stars star id params
func (o *GetUniverseStarsStarIDParams) WithXUserAgent(xUserAgent *string) *GetUniverseStarsStarIDParams {
	o.SetXUserAgent(xUserAgent)
	return o
}

// SetXUserAgent adds the xUserAgent to the get universe stars star id params
func (o *GetUniverseStarsStarIDParams) SetXUserAgent(xUserAgent *string) {
	o.XUserAgent = xUserAgent
}

// WithDatasource adds the datasource to the get universe stars star id params
func (o *GetUniverseStarsStarIDParams) WithDatasource(datasource *string) *GetUniverseStarsStarIDParams {
	o.SetDatasource(datasource)
	return o
}

// SetDatasource adds the datasource to the get universe stars star id params
func (o *GetUniverseStarsStarIDParams) SetDatasource(datasource *string) {
	o.Datasource = datasource
}

// WithStarID adds the starID to the get universe stars star id params
func (o *GetUniverseStarsStarIDParams) WithStarID(starID int32) *GetUniverseStarsStarIDParams {
	o.SetStarID(starID)
	return o
}

// SetStarID adds the starId to the get universe stars star id params
func (o *GetUniverseStarsStarIDParams) SetStarID(starID int32) {
	o.StarID = starID
}

// WithUserAgent adds the userAgent to the get universe stars star id params
func (o *GetUniverseStarsStarIDParams) WithUserAgent(userAgent *string) *GetUniverseStarsStarIDParams {
	o.SetUserAgent(userAgent)
	return o
}

// SetUserAgent adds the userAgent to the get universe stars star id params
func (o *GetUniverseStarsStarIDParams) SetUserAgent(userAgent *string) {
	o.UserAgent = userAgent
}

// WriteToRequest writes these params to a swagger request
func (o *GetUniverseStarsStarIDParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error

	if o.XUserAgent != nil {

		// header param X-User-Agent
		if err := r.SetHeaderParam("X-User-Agent", *o.XUserAgent); err != nil {
			return err
		}

	}

	if o.Datasource != nil {

		// query param datasource
		var qrDatasource string
		if o.Datasource != nil {
			qrDatasource = *o.Datasource
		}
		qDatasource := qrDatasource
		if qDatasource != "" {
			if err := r.SetQueryParam("datasource", qDatasource); err != nil {
				return err
			}
		}

	}

	// path param star_id
	if err := r.SetPathParam("star_id", swag.FormatInt32(o.StarID)); err != nil {
		return err
	}

	if o.UserAgent != nil {

		// query param user_agent
		var qrUserAgent string
		if o.UserAgent != nil {
			qrUserAgent = *o.UserAgent
		}
		qUserAgent := qrUserAgent
		if qUserAgent != "" {
			if err := r.SetQueryParam("user_agent", qUserAgent); err != nil {
				return err
			}
		}

	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
