// Code generated by go-swagger; DO NOT EDIT.

package wars

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"net/http"
	"time"

	"golang.org/x/net/context"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/swag"

	strfmt "github.com/go-openapi/strfmt"
)

// NewGetWarsParams creates a new GetWarsParams object
// with the default values initialized.
func NewGetWarsParams() *GetWarsParams {
	var (
		datasourceDefault = string("tranquility")
	)
	return &GetWarsParams{
		Datasource: &datasourceDefault,

		timeout: cr.DefaultTimeout,
	}
}

// NewGetWarsParamsWithTimeout creates a new GetWarsParams object
// with the default values initialized, and the ability to set a timeout on a request
func NewGetWarsParamsWithTimeout(timeout time.Duration) *GetWarsParams {
	var (
		datasourceDefault = string("tranquility")
	)
	return &GetWarsParams{
		Datasource: &datasourceDefault,

		timeout: timeout,
	}
}

// NewGetWarsParamsWithContext creates a new GetWarsParams object
// with the default values initialized, and the ability to set a context for a request
func NewGetWarsParamsWithContext(ctx context.Context) *GetWarsParams {
	var (
		datasourceDefault = string("tranquility")
	)
	return &GetWarsParams{
		Datasource: &datasourceDefault,

		Context: ctx,
	}
}

// NewGetWarsParamsWithHTTPClient creates a new GetWarsParams object
// with the default values initialized, and the ability to set a custom HTTPClient for a request
func NewGetWarsParamsWithHTTPClient(client *http.Client) *GetWarsParams {
	var (
		datasourceDefault = string("tranquility")
	)
	return &GetWarsParams{
		Datasource: &datasourceDefault,
		HTTPClient: client,
	}
}

/*GetWarsParams contains all the parameters to send to the API endpoint
for the get wars operation typically these are written to a http.Request
*/
type GetWarsParams struct {

	/*XUserAgent
	  Client identifier, takes precedence over User-Agent

	*/
	XUserAgent *string
	/*Datasource
	  The server name you would like data from

	*/
	Datasource *string
	/*MaxWarID
	  Only return wars with ID smaller than this.

	*/
	MaxWarID *int32
	/*UserAgent
	  Client identifier, takes precedence over headers

	*/
	UserAgent *string

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithTimeout adds the timeout to the get wars params
func (o *GetWarsParams) WithTimeout(timeout time.Duration) *GetWarsParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the get wars params
func (o *GetWarsParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the get wars params
func (o *GetWarsParams) WithContext(ctx context.Context) *GetWarsParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the get wars params
func (o *GetWarsParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the get wars params
func (o *GetWarsParams) WithHTTPClient(client *http.Client) *GetWarsParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the get wars params
func (o *GetWarsParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithXUserAgent adds the xUserAgent to the get wars params
func (o *GetWarsParams) WithXUserAgent(xUserAgent *string) *GetWarsParams {
	o.SetXUserAgent(xUserAgent)
	return o
}

// SetXUserAgent adds the xUserAgent to the get wars params
func (o *GetWarsParams) SetXUserAgent(xUserAgent *string) {
	o.XUserAgent = xUserAgent
}

// WithDatasource adds the datasource to the get wars params
func (o *GetWarsParams) WithDatasource(datasource *string) *GetWarsParams {
	o.SetDatasource(datasource)
	return o
}

// SetDatasource adds the datasource to the get wars params
func (o *GetWarsParams) SetDatasource(datasource *string) {
	o.Datasource = datasource
}

// WithMaxWarID adds the maxWarID to the get wars params
func (o *GetWarsParams) WithMaxWarID(maxWarID *int32) *GetWarsParams {
	o.SetMaxWarID(maxWarID)
	return o
}

// SetMaxWarID adds the maxWarId to the get wars params
func (o *GetWarsParams) SetMaxWarID(maxWarID *int32) {
	o.MaxWarID = maxWarID
}

// WithUserAgent adds the userAgent to the get wars params
func (o *GetWarsParams) WithUserAgent(userAgent *string) *GetWarsParams {
	o.SetUserAgent(userAgent)
	return o
}

// SetUserAgent adds the userAgent to the get wars params
func (o *GetWarsParams) SetUserAgent(userAgent *string) {
	o.UserAgent = userAgent
}

// WriteToRequest writes these params to a swagger request
func (o *GetWarsParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error

	if o.XUserAgent != nil {

		// header param X-User-Agent
		if err := r.SetHeaderParam("X-User-Agent", *o.XUserAgent); err != nil {
			return err
		}

	}

	if o.Datasource != nil {

		// query param datasource
		var qrDatasource string
		if o.Datasource != nil {
			qrDatasource = *o.Datasource
		}
		qDatasource := qrDatasource
		if qDatasource != "" {
			if err := r.SetQueryParam("datasource", qDatasource); err != nil {
				return err
			}
		}

	}

	if o.MaxWarID != nil {

		// query param max_war_id
		var qrMaxWarID int32
		if o.MaxWarID != nil {
			qrMaxWarID = *o.MaxWarID
		}
		qMaxWarID := swag.FormatInt32(qrMaxWarID)
		if qMaxWarID != "" {
			if err := r.SetQueryParam("max_war_id", qMaxWarID); err != nil {
				return err
			}
		}

	}

	if o.UserAgent != nil {

		// query param user_agent
		var qrUserAgent string
		if o.UserAgent != nil {
			qrUserAgent = *o.UserAgent
		}
		qUserAgent := qrUserAgent
		if qUserAgent != "" {
			if err := r.SetQueryParam("user_agent", qUserAgent); err != nil {
				return err
			}
		}

	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
